ifndef cameraTarget_wdl;
define cameraTarget_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 4
// date: 050412
//
// title: Camera Target
// class: CAMERA
// type: SUPPORT
// image: cameraTarget.pcx
// help: Contains position and orientation of a target (i.e. the player) that is
// help:of interest to certain cameras (e.g. cameraOrbit01, camera3rd, etc.).
// help: The angle and offset position of the head is also tracked here.
//
//
// prefix: cameraTarget_
// idcode: 009
//
// ENDHEADER
// ---------------------------------------------------------------------



//----------------------------------------------------------------------
// Shared values

// pointer to the entity (used for genius)
entity*	cameraTarget_ent;

// the camera target position vector
var cameraTarget_pos_vec[3];
// the camera target orientation (angle) vector
var cameraTarget_ang_vec[3];

// is this view "avatar" (e.g. 1st person view)
var	cameraTarget_avatar_view_q;


starter 	CameraTarget_Init()
{
	diag("\nWDL-Loaded:cameraTarget.wdl");
}


endif;