ifndef debug_wdl;
define debug_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 4
// date: 050412
//
// title: Debug Toys (01)
// class: TOOLS
// type: DEV
// image: debug01.pcx
// help: A collection of useful functions/objects that can be used to help debug.
//
// needs:
// external:   ++++++++
//
// prefix: debug01_
// idcode: 034
//
// ENDHEADER
// ---------------------------------------------------------------------


entity* debug01_temp_ent;
var	debug01_temp_val;
var	debug01_temp_color[3];

// ray sprite
string	debug01_ray_mdl, <ray.mdl>;
// ball model
string	debug01_ball_mdl, <ball.mdl>;
// axis model
string	debug01_axis_mdl, <xyz.mdl>;


// Desc: action for axis
function	Debug01_Axis_Action()
{
	MY.PASSABLE = ON;
	my.red = debug01_temp_color.red;
	my.green = debug01_temp_color.green;
	my.blue = debug01_temp_color.blue;
	my.lightrange = 0;
	my.light = on;
/*
	MY.TRANSPARENT = ON;
	MY.ALPHA = 95;
	MY.BLEND = ON;
	MY.FLARE = ON;
*/
	MY.SKILL1 = debug01_temp_val;
	if(MY.SKILL1 < 1) { MY.SKILL1 = 1; }

	wait(MY.SKILL1);
	ent_remove(me);
}


function	Debug01_Axis(&vec, scale, life)
{
	debug01_temp_val = life;
	ent_create(debug01_axis_mdl, vec, Debug01_Axis_Action);
}


// Desc: action for ball
function	Debug01_Ball_Action()
{
	vec_scale(MY.SCALE_X,0.125);
	MY.PASSABLE = ON;
   MY.LIGHT = ON;       // illuminate myself
	MY.LIGHTBLUE = 255;   // blue laser
/*
	MY.TRANSPARENT = ON;
	MY.ALPHA = 95;
	MY.BLEND = ON;
	MY.FLARE = ON;
*/
	MY.SKILL1 = debug01_temp_val;
	if(MY.SKILL1 < 1) { MY.SKILL1 = 1; }

	waitt(MY.SKILL1);
	ent_remove(me);
}

function	Debug01_Ball(&vec,life)
{
	debug01_temp_val = life;
	ent_create(debug01_ball_mdl, vec, Debug01_Ball_Action);
}

// Desc: action for ray
function	Debug01_Ray_Action()
{
	MY.PASSABLE = ON;
   MY.LIGHT = ON;       // illuminate myself
	MY.LIGHTBLUE = 255;   // blue laser
/*
	MY.TRANSPARENT = ON;
	MY.ALPHA = 95;
	MY.BLEND = ON;
	MY.FLARE = ON;
*/
	MY.SKILL1 = debug01_temp_val;
	if(MY.SKILL1 < 1) { MY.SKILL1 = 1; }

	waitt(MY.SKILL1);
	ent_remove(me);
}

// Desc: Draw a visible beam/ray from point "from_vec" to a point "to_vec"
//		Remove after "life" ticks
function	Debug01_Ray(&from_vec, &to_vec, life)
{
	var	length;

	vec_diff(temp,to_vec,from_vec); 	// create a ray

	length = vec_length(temp);

	debug01_temp_val = life;
	debug01_temp_ent = ent_create(debug01_ray_mdl, nullvector, Debug01_Ray_Action);

	debug01_temp_ent.SCALE_X = length/10.0;	// 10 = ray model length
	vec_to_angle(debug01_temp_ent.pan,temp); 	// rotate

	vec_normalize(temp,(length/2));         	// translate
	vec_add(debug01_temp_ent.x,from_vec);
	vec_add(debug01_temp_ent.x,temp);
}

// Example:
// Debug01_Draw_Line(player.x,target.x);
var	Debug01_Red = 255;
var	Debug01_Green = 0;
var	Debug01_Blue = 0;
function Debug01_Part_Line()
{
	my.lifespan = 0.1;
	my.streak = on;
	my.red = Debug01_Red;
	my.green = Debug01_Green;
	my.blue = Debug01_Blue;
	my.size = 1;
	my.function = NULL;
}

function Debug01_Draw_Line(&start,&end)
{
	vec_diff(temp,end,start);
	effect_local(Debug01_Part_Line,1,start,temp);
}


endif;