/*********************************************************************
**									Intense Pathfinding                      **
**                         -------------------                      **
**                                             By Intense Illusions **
*********************************************************************/




/*********************************************
**********************************************
**                 ASSIGNMENTS              **
**********************************************
*********************************************/


// Use Ellipsoid collision and physics engine enabled.
var enable_polycollision = 2; 
var floor_trace=2;



//IMPORTANT DEFINES: Change this Values to your game needs!


//Size of one meter in pixels (One good way to get this value, is by measuring the height in pixels of your humanoid models)
define is_meter,45; //One Meter Equals 45 pixels.



//How Close to the waypoint must the Npc get before it is assumed that it reached it
define is_ai_WayPointTriggerRange,0.9; //in meters



//How many Gravity checks to make per c_trace on RunTime
//Low Value: High fps, higher chance not to detect a gap between two waypoints. 
	//It will result in the Npc fall through the gap although it thought the path ws safe, maybe never Reaching its destination!
//High Value: Low fps, lower chance not to detect a gap between two waypoints.
	//Designing Safer Paths
define is_ai_cGravitySteps,20; //20 Downward Gravity Traces between two paths


//How far below should the Gravity check be, in pixels
//Low Value: High fps, May not be enough to detect ground below a waypoint, thus eliminating the wapoint
//High Value: Low fps, Safer on Gravity Checks
//Change This Value according to your level. If you have  bridge, and there's ground 5000 pixels below that bridge
	//Where the Npc could be expected to fall down, make this value 5000 or more
define is_ai_DownwardsTrace,500;	//Detects Ground up to 500 pixels downwards



//How far below is the NPCs willing to fall down. Sometimes a jump down a bridge would result in the shortest path
//However, the NPC may take damage when falling from big distances so it might prefer taking the long route instead.
//Higher values will allow the NPC to take the shortest route possible
//Lower values will force the NPC to look for the safest passage(walk down the stairs, instead of falling down a cliff)
//is_ai_MaximumFall can't be a bigger value than is_ai_DownwardsTrace
define is_ai_MaximumFall,500;








//NPC SKILLS

define is_vIndex,skill96;

DEFINE goal_position_z,skill94;
DEFINE goal_position_y,skill93;
DEFINE goal_position_x,skill92;

define is_bIsStuck,skill90;

DEFINE boostVectorZ,skill86;
DEFINE boostVectorY,skill85;
DEFINE boostVectorX,skill84;

DEFINE is_cMoveMode,SKILL83;
define PanForce,skill80;



//NPC FLAGS
define is_fGraphMaker,flag6;




//DEFINE CONSTANTS
define is_cStopped,0;
define is_cMoving,1;

define is_cIgnoreAllDynamicModels,1;
define is_cIgnoreNoModels,2;


//Colours
define is_RED,1;
define is_GREEN,2;
define is_YELLOW,3;
define is_BLACK,4;
define is_WHITE,5;
define is_ORANGE,6;
define is_BLUE,7;
define is_BROWN,8;
define is_PURPLE,9;
define is_PINK,10;

//Logic
define is_FALSE,0;
define is_TRUE,1;


//Directions
define is_NO_DIRECTON,0;
define is_UP,1;
define is_DOWN,2;
define is_LEFT,3;
define is_RIGHT,4;


//Time
define is_SecondInTicks,16;

define MinuteInSeconds,60;
define HourInMinutes,60;
define DayInHours,24;
define YearInDays,360;


//Misc
define is_cMaxEntities,1000;  //Max Number of Pathfinding Entities Allowed
define MaxWayPoints,1000;		//Max Number of WayPoints Allowed


define infinity,999999;
define undefined,-1;
define undefinedAngle,-6666;
define notFound,-66;

define is_ai_GoalWayPoint,-100;
define is_ai_PathEnded,-101;




//Vars

var vGraphPercentageDone;

var bGraphDone;

var entity_count = 0;
var entity_handle[is_cMaxEntities];//handle array to all the entities



var waypoint_count = -1;	//*** waypoint count(differs from other counts cause first waypoints is 0 instead of 1)
var NumOfWayPoints = 0;	//*** number of waypoints on map

var NumOfWayEdges = 0; //Number of Edges discovered

var waypoint_handle[MaxWayPoints];//***	handle array to all the waypoints, MaxWaypoints max

var is_ai_Pathfind_OptimizedSimulatedSteps;

var GetWayPointClosestTo_ReturnDistance;

var is_ai_bDebugMode;
var is_ai_bSuperDebugMode;
var is_ai_bMakeGraphMode;
var bEnableMouseInFreeCamera=IS_TRUE;

var is_ai_GraphAssigned;


var is_tempvec1[3];
var is_tempvec2[3];
var is_tempvec3[3];
var is_tempvec4[3];
var is_tempvec5[3];
var is_tempvec6[3];

var is_temp1;
var is_temp2;
var is_temp3;

var debugT;


var TargetPosX;
var TargetPosY;
var TargetPosZ;



//Strings

string sGraphTimeEstimated[100];
string sGraphTimeRemaining[100];

string sRunningMode[500];

string is_sTemp1[10000];
string is_sTemp2[10000];
string is_sTemp3[10000];
string is_sTemp4[10000];




//Entity Pointers

entity* is_tempent;
entity* is_tempent2;
entity* is_tempent3;
entity* is_tempent4;
entity* Debug_tp;



//fonts
font Arial_font = "Arial",1,12; // truetype font


//Bmaps
BMAP arrow = <arrow.pcx>; 




//function prototypes
function is_Action_Move_To(PosX,PosY,PosZ,eTarget);




/*********************************************
**********************************************
**            INCLUDES PART 1               **
**********************************************
*********************************************/


include <IaI_gid01.wdl>;	// global ids
include <IaI_display00.wdl>;  // basic display settings
include <IaI_cameraTarget.wdl>;
include <IaI_miscInput01.wdl>;
include <IaI_bipedPhy01.wdl>;
include <IaI_cameraSelect.wdl>;
include <IaI_particle00.wdl>;






/*********************************************
**********************************************
**            USEFULL FUCTIONS              **
**********************************************
*********************************************/


//It is recommended that you study this functions so that you may find
//some use for them in your own projects




//Returns the Angle Required for eAgent to turn at eTarget
function is_ReturnAngleForTurningToEntity(eAgent,eTarget)
{
	my=eAgent;
	you=eTarget;
	
	// get the direction from the entity MY to the entity YOU
	vec_set(temp,you.x); 
	vec_sub(temp,my.x);
	vec_to_angle(is_tempvec5,temp);

	return(is_tempvec5.pan);
}



//Return the Angle Required for eAgent to turn to PosX,Y,Z
function is_ReturnAngleForTurningToPos(eAgent,PosX,PosY,PosZ)
{
	my=eAgent;
	
	// get the direction from the entity MY to the entity YOU
	temp.x=PosX;
	temp.y=PosY;
	temp.z=PosZ;
	vec_sub(temp,my.x);
	vec_to_angle(is_tempvec5,temp);

	return(is_tempvec5.pan);
}



//Return the Angle for SourcePos to turn to TargetPos
function is_ReturnAngleForTurningPosToPos(&SourcePos,&TargetPos)
{
	//Source Position
	is_tempvec4.x=SourcePos[0];
	is_tempvec4.y=SourcePos[1];
	is_tempvec4.z=SourcePos[2];
	
	//Target Position
	temp.x=TargetPos[0];
	temp.y=TargetPos[1];
	temp.z=TargetPos[2];
	
	
	vec_sub(temp,is_tempvec4.x);
	vec_to_angle(is_tempvec5,temp);

	return(is_tempvec5.pan);
}


//Return the Percentage Value of AValue in the scale 0-MaxValue
//(if Avalue is 5 and MaxValue is 10, this function will return 50)
function is_ai_percentage(Avalue,MaxValue)
{
	//Prevent division by Zero
	if (MaxValue==0) {return(0);}
	
	//Return Value
	return (max(0,min((Avalue*100)/MaxValue,100)));
}



//Convert AValue from Scale 0-MaxValue into the Scale 0-X
//(If Avalue is 5, MaxValue is 10 and X is 200, this function will return 100)
//If X is 100, it works exacly like the function above
function is_ai_ZeroToXScale(Avalue,MaxValue,X)
{
	//Prevent division by Zero
	if (MaxValue==0) {return(0);}
	
	//Return Value
	return (max(0,min((Avalue*X)/MaxValue,X)));
}



//Returns position Which is in 'distance' Radious from SourcePos, in a 'angle' angle.
//Since a vector cannot be returned, I use a function parmeter to 'return' the Position instead
function is_GetPosVecByRadious(&SourcePos,angle,distance,&ReturnedPos)
{
	ReturnedPos[0]=distance*cos(angle)+SourcePos[0];
	ReturnedPos[1]=distance*sin(angle)+SourcePos[1];
	ReturnedPos[2]=SourcePos[2]; 
}



// Desc: draw line from start to end
// Note! Only works in Commercial edition or higher (streak effect).
function is_DrawLine(&start,&end,colour)
{
	vec_diff(temp,end,start);
	
	if (colour==IS_RED) {effect(Particle00_DrawRedLine_Func,1,start,temp);}
	if (colour==IS_BLUE) {effect(Particle00_DrawBlueLine_Func,1,start,temp);}
	if (colour==IS_YELLOW) {effect(Particle00_DrawYellowLine_Func,1,start,temp);}
	if (colour==IS_GREEN) {effect(Particle00_DrawGreenLine_Func,1,start,temp);}
}


// Desc: draw Permanent line from start to end
// Note! Only works in Commercial edition or higher (streak effect).
function is_DrawPermLine(&start,&end,colour)
{
	vec_diff(temp,end,start);
	
	if (colour==IS_RED) {effect(Particle00_DrawPermThinRedLine_Func,1,start,temp);}
	if (colour==IS_BLUE) {effect(Particle00_DrawPermBlueLine_Func,1,start,temp);}
	if (colour==IS_YELLOW) {effect(Particle00_DrawPermYellowLine_Func,1,start,temp);}
	if (colour==IS_GREEN) {effect(Particle00_DrawPermGreenLine_Func,1,start,temp);}
}



//Return A Random Value, between 'from' and 'to'
function is_IntRandom(from,to)
{
	return(from+int(random((to+1)-from)));
}




//Very usefull function which will display visually a c_trace
//The attempted c_trace is drawn with a thin red line.
//The c_trace that actually kept going with no obstacles found is drawn with a thick blue line
//Syntax is the same as with c_trace(use global vectors as parameters)
function c_trace_debug(&SourcePoint,&TargetPoint,traceM)
{
	var trace_return;
	

	//Draw the c_trace attempt in a red thin line
	is_DrawPermLine(SourcePoint.x,TargetPoint.x,IS_RED);
	
	//Time the c_trace function
	timer();	
	trace_return=c_trace(SourcePoint.x,TargetPoint.x,traceM);
	debugT=timer();
	
	//Draw the successfull journey of a c_trace with a thick blue line
	if (trace_hit) {is_DrawPermLine(SourcePoint.x,target.x,IS_BLUE);}
		else {is_DrawPermLine(SourcePoint.x,TargetPoint.x,IS_BLUE);}
	
	//Return the distance, just as c_trace does
	return(trace_return);
}






/*********************************************
**********************************************
**              INCLUDES PART 2             **
**********************************************
*********************************************/


include <is_DataStructure.wdl>;	//A Few Data Structures
include <is_PoV_Pathfind.wdl>;//Points of Visibility Pathfinding

include <is_ai_subactions.wdl>;	//Simple Actions for the Npc
include <is_ai_actions.wdl>;		//Long Term Actions for the Npc

include <IaI_cameraFree01.wdl>;	//A6 Templates Free Camera Movement
include <is_Interface.wdl>;		//WED Actions and GUI







/*********************************************
**********************************************
**             MISC FUCTIONS                **
**********************************************
*********************************************/


//This functions are mainly for Camera and mouse movement. Skip through them. Not recommended to be used in your own projects either.
//Just take a look on the ChoosePosition function which explains how to command an Npc to travel to a position(or towards another entity)



//Toggles Mouse(visible, not visible
function mouse_toggle
{  
 	MOUSE_MAP = arrow;

	if (MOUSE_MODE == 2) // was it already on?
	{  
		MOUSE_MODE=0;
		bEnableMouseInFreeCamera=IS_TRUE;
	}
	else
	{
  		MOUSE_MODE=2;
  		
  		MOUSE_POS.X=300;
  		MOUSE_POS.Y=300;
  		
  		bEnableMouseInFreeCamera=IS_FALSE;
	}
  
	while (MOUSE_MODE!=0) // move it over the screen
	{  
		MOUSE_POS.X = POINTER.X;
		MOUSE_POS.Y = POINTER.Y;;
		wait(1);
	}
}


//Move the Mouse Pointer, or rotate the camera if right_click is pressed
function Mouse_Movement()
{
	MOUSE_MAP=arrow;
	MOUSE_MODE=2;
	
	MOUSE_POS.X=screen_size.x/2;
	MOUSE_POS.Y=screen_size.y/2;
	
	while (1)
	{
		if (mouse_right) {bEnableMouseInFreeCamera=IS_TRUE;}
		
		else 
		{
			bEnableMouseInFreeCamera=IS_FALSE;
			
		  MOUSE_POS.X += mickey.x*time*3;
	 	  MOUSE_POS.Y += mickey.y*time*3;
		}
		
		
		wait(1);
	}	
}





//Command the Npc to move somewhere.
function ChoosePosition()
{
	var ValidPosition=IS_TRUE;
	var FoundPath;
	var MyOriginHeight;
	

	//Kill previous Red lines
	KillLines=1;
	wait(1);
	KillLines=0;
	
	//Retreive the Pointr of the npc(1, since only one entity is in the level)
	my=id_to_ptr(1);
	//Stop the entity, if it was previously going somewhere else
	my.is_cMoveMode=is_cStopped;
	
	//Wait for the previous action to finish
	wait(1);


	//Find the origint point of the Agent
	MyOriginHeight=my.min_z*(-1);



	//Target A position from mouse pointer
	temp.x = MOUSE_POS.x;
	temp.y = MOUSE_POS.y;
	temp.z = 10000;
	vec_for_screen(temp,CAMERA);
	c_trace(camera.x,temp,ignore_passable+ignore_passents);

	//Save the result as the initial Target Position
	TargetPosX=target.x;
	TargetPosY=target.y;
	TargetPosZ=target.z;
	

	//If Nothing is hit mark position as invalid
	if (!trace_hit) {ValidPosition=IS_FALSE;}

	//If position found is inside solid block, mark it as invalid
	if (c_content(vector(target.x,target.y,target.z+20),0)==CONTENT_SOLID) {ValidPosition=IS_FALSE;}
	
	//Figure out of position is in the air due to player clicking on a steep vertical surface
	if (ValidPosition)
	{
		//Downwards trace to check if position is hovering on air
		c_trace(vector(target.x,target.y,target.z+20),vector(target.x,target.y,target.z-MyOriginHeight),ignore_passable+ignore_passents);
		
		//If Nothing is hit on the downwards trace, mark position as invalid
		if (!trace_hit) {ValidPosition=IS_FALSE;}
	}

	
	
	if (ValidPosition)
	{
		//Clamp target position to the ground
		ClampPosition(vector(TargetPosX,TargetPosY,TargetPosZ+20),MyOriginHeight,is_temp2);
		
		//Save the result as the final Target Position
		TargetPosX=is_temp2.x;
		TargetPosY=is_temp2.y;
		TargetPosZ=is_temp2.z;
		
	
	
		//Important: This is how you command the Npc to move somewhere!
		//It returns TRUE(1) if a path is found or FALSE(0) otherwise
		//If you need the Npc to move to the position of another entity instead, use the same function with this syntax:
			//is_Action_Move_To(0,0,0,you);   (you being the pointer of the entity that you want the Npc to go to)
		FoundPath=is_Action_Move_To(TargetPosX,TargetPosY,TargetPosZ,null);
	}
	
	//Color the X model green if Path was found, or red otherwise
	if (FoundPath) {Debug_tp.skin=is_GREEN;}
		else {Debug_tp.skin=is_RED;}
	
	//Set the position of the X model to the Position the Npc is commanded to go to
	vec_set(Debug_tp.x,vector(TargetPosX,TargetPosY,TargetPosZ));
}



//If We're not in Graph_making mode, use Mouse left clicking to command the Npc to go somewhere
ifndef MAKE_GRAPH;
	ON_MOUSE_LEFT = ChoosePosition; 
endif;



//Starter function to initialize camera and mouse movement
starter is_ai_Starter()
{
	move_friction = 0;	//no friction
	randomize();	//generate a new seed of random numbers


	//If not in Graph_Making mode, Set up Mouse and Camera Movement
	ifndef MAKE_GRAPH;
		Mouse_Movement();
		sleep(1);
		
		//Switch to Free Camera
		CameraSelect_Next(); 
	endif;

	
	//Start in Debug Mode(path visible with red lines)
	ToggleDebugMode(); 
}



//Register a Waypoint in the Waypoints Array, and give the waypoint a unique id number
function RegisterWayPoint()
{
	waypoint_count+=1;
	NumOfWayPoints+=1;
	
	waypoint_handle[waypoint_count]=handle(me);
	my.is_vIndex=waypoint_count;
}


//Register an Npc in the Npcs array, and give the npc a unique id number
function RegisterMe()
{
	entity_count += 1;
	entity_handle[entity_count] = handle(me);
	my.is_vIndex=entity_count;
}



//Cast Shadow according to Gstudio Version
function ShadowMe()
{
	ifdef std;
	// set up for standard mode
	  	my.shadow = OFF;	// no dynamic shadows
		drop_shadow();
	ifelse;  // not std
	ifdef extra;
		// set up for extra mode
	  	my.shadow = OFF;	// no dynamic shadows
		drop_shadow();
	ifelse; // not std, not extra
	 	my.shadow = ON;	// dynamic shadows
	endif;
	endif;
}



//Get Npc Pointer by id
function id_to_ptr(id)
{
	//Catch bad id input
	if (entity_handle[id]==null) {return (null);}
	
	//Return pointer
	return (ptr_for_handle(entity_handle[id]));
}


//Get Waypoint Pointer by Id
function waypoint_to_ptr(id)
{
		//-->Debug: Catch Broken Id if one occured
		//if (id>waypoint_count || id<0) {breakpoint; id=id;}
		
	//Catch bad id input
	if (id>waypoint_count || id<0) {id=0;}
	
	return (ptr_for_handle(waypoint_handle[id]));
}


//Freeze Game
function pause()
{ 
	if(freeze_mode == 2) // all frozen??
	{
		freeze_mode = 0; // go on
	}
	else
	{
		freeze_mode = 2; // pause
	}
} 

//Freeze on key 'p'
on_p=pause;


